
// AkidukiRadioDlg.cpp : t@C
//

#include "stdafx.h"
#include "AkidukiRadio.h"
#include "AkidukiRadioDlg.h"

#include <string.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAkidukiRadioDlg _CAO




CAkidukiRadioDlg::CAkidukiRadioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAkidukiRadioDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	_freq_am = 594;
	_freq_fm = 8250;

	hComPort = INVALID_HANDLE_VALUE;
}

CAkidukiRadioDlg::~CAkidukiRadioDlg()
{
	OnMuteClicked();
	open_com_port(0);
}


void CAkidukiRadioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_BAND, combobox_port);
	DDX_Control(pDX, IDC_EDIT_FREQ, edit_freq);
}

BEGIN_MESSAGE_MAP(CAkidukiRadioDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CAkidukiRadioDlg::OnBnClickedButton1)
	ON_CBN_SELCHANGE(IDC_COMBO_BAND, &CAkidukiRadioDlg::OnCbnSelchangeCombo1)
	ON_EN_KILLFOCUS(IDC_EDIT_FREQ, &CAkidukiRadioDlg::OnEnKillfocusEdit1)
	ON_BN_CLICKED(IDC_BUTTON_MUTE, &CAkidukiRadioDlg::OnMuteClicked)
	ON_BN_CLICKED(IDC_BUTTON_OPEN, &CAkidukiRadioDlg::OnBnClickedButtonOpen)
END_MESSAGE_MAP()


// CAkidukiRadioDlg bZ[W nh


void CAkidukiRadioDlg::enable_buttons(bool f)
{
	::EnableWindow(::GetDlgItem(GetSafeHwnd(), IDOK), f);
	::EnableWindow(::GetDlgItem(GetSafeHwnd(), IDC_BUTTON_MUTE), f);
}

void CAkidukiRadioDlg::open_com_port(wchar_t const *path)
{
	if (hComPort != INVALID_HANDLE_VALUE) {
		CloseHandle(hComPort);
		if (!path) {
			hComPort = 0;
			return;
		}
	}
	hComPort = CreateFile(path, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hComPort != INVALID_HANDLE_VALUE) {
		DCB dcb;
		GetCommState(hComPort, &dcb);
		dcb.BaudRate = 9600;
		dcb.ByteSize = 8;
		dcb.Parity = NOPARITY;
		dcb.fParity = FALSE;
		dcb.StopBits = ONESTOPBIT;
		SetCommState(hComPort, &dcb);
		enable_buttons(true);
	} else {
		enable_buttons(false);
	}
}


BOOL CAkidukiRadioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	{
		std::vector<std::wstring> const *ports = theApp.GetSerialPorts();
		for (int i = 0; i < (int)ports->size(); i++) {
			wchar_t const *p = ports->at(i).c_str();
			if (wcsncmp(p, L"\\\\.\\", 4) == 0) {
				p += 4;
			}
			combobox_port.AddString(p);
		}
		if (ports->size() > 0) {
			combobox_port.SetCurSel(0);
			open_com_port(ports->front().c_str());
		}
	}

	enable_buttons(false);
	::SendMessage(::GetDlgItem(GetSafeHwnd(), IDC_RADIO1), BM_CLICK, 0, 0);

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CAkidukiRadioDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CAkidukiRadioDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


BOOL CAkidukiRadioDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
	case MAKELONG(IDC_RADIO1, BN_CLICKED): // am
		_band = AM;
		{
			wchar_t tmp[100];
			swprintf(tmp, 100, L"%u", _freq_am);
			edit_freq.SetWindowText(tmp);
		}
		::SetWindowText(::GetDlgItem(GetSafeHwnd(), IDC_STATIC_UNIT), L"kHz");
		break;
	case MAKELONG(IDC_RADIO2, BN_CLICKED): // fm
		_band = FM;
		{
			wchar_t tmp[100];
			swprintf(tmp, 100, L"%.2f", _freq_fm / 100.0);
			edit_freq.SetWindowText(tmp);
		}
		::SetWindowText(::GetDlgItem(GetSafeHwnd(), IDC_STATIC_UNIT), L"MHz");
		break;
	}

	return CDialog::OnCommand(wParam, lParam);
}

void CAkidukiRadioDlg::OnBnClickedButton1()
{
	if (hComPort == INVALID_HANDLE_VALUE) {
		return;
	}
	if (_band == AM) {
		char tmp[100];
		sprintf(tmp, "%u\r", _freq_am);
		DWORD n;
		WriteFile(hComPort, tmp, strlen(tmp), &n, 0);
		WriteFile(hComPort, "am\r", 3, &n, 0);
	} else {
		char tmp[100];
		sprintf(tmp, "%u\r", _freq_fm);
		DWORD n;
		WriteFile(hComPort, tmp, strlen(tmp), &n, 0);
		WriteFile(hComPort, "fm\r", 3, &n, 0);
	}
}

void CAkidukiRadioDlg::OnCbnSelchangeCombo1()
{
	OnMuteClicked();
	open_com_port(0);
}

void CAkidukiRadioDlg::OnEnKillfocusEdit1()
{
	wchar_t tmp[100];
	edit_freq.GetWindowText(tmp, 100);
	if (_band == AM) {
		_freq_am = _wtoi(tmp);
	} else if (_band == FM) {
		_freq_fm = (int)(_wtof(tmp) * 100);
	}
}

void CAkidukiRadioDlg::OnMuteClicked()
{
	if (hComPort == INVALID_HANDLE_VALUE) {
		return;
	}
	DWORD n;
	WriteFile(hComPort, "mute\r", 5, &n, 0);
}

void CAkidukiRadioDlg::OnBnClickedButtonOpen()
{
	int i = combobox_port.GetCurSel();
	std::vector<std::wstring> const *ports = theApp.GetSerialPorts();
	if (i >= 0 && i < ports->size()) {
		open_com_port(ports->at(i).c_str());
	}
}
